package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.lang.dpml.ast.ILocation;
import org.netkernel.lang.dpml.ast.IReferenceVariable;
import org.netkernel.lang.dpml.ast.IScope;


/** A reference to another assignment which must be dynamically resolved
 * @author Tony Butterfield
 *
 */
public class AssignmentReference extends VariableImpl implements IReferenceVariable
{	private final String mReference;
	
	public AssignmentReference(String aName, IScope aScope, ILocation aLocation, String aReference)
	{	super(aName,aScope,aLocation);
		mReference=aReference;
	}

	public String getReference()
	{	return mReference;
	}
	
	public String toString()
	{	return "Ref["+mReference+"]";
	}
	
}
