package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.lang.dpml.ast.IIdentifierVariable;
import org.netkernel.lang.dpml.ast.ILocation;
import org.netkernel.lang.dpml.ast.IScope;
import org.netkernel.lang.dpml.endpoint.DPMLSubrequestContext;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.request.IRequestScopeLevel;


public class LiteralIndentifier extends VariableImpl implements IIdentifierVariable
{
	private final String mReference;
	private final boolean mAbsolute;
	
	public LiteralIndentifier(String aName, IScope aScope, ILocation aLocation, String aReference, boolean aAbsolute)
	{	super(aName, aScope, aLocation);
		mReference=aAbsolute?aReference:escapeArgIdentifier(aReference);
		mAbsolute=aAbsolute;
	}

	public String getIdentifier(INKFRequestContext aContext, IRequestScopeLevel aSubRequestContext)
	{	return mReference;
	}
	
	public boolean isAbsolute()
	{	return mAbsolute;
	}
	
	public boolean equals(Object aOther)
	{	return aOther instanceof LiteralIndentifier && ((LiteralIndentifier)aOther).mReference.equals(mReference);
	}
	
	public static String escapeArgIdentifier(String aIdentifier)
	{	String result=aIdentifier;
		if (result.startsWith(DPMLSubrequestContext.ARG_SCHEME))
		{	result = DPMLSubrequestContext.ARG_SCHEME_ESC+result.substring(DPMLSubrequestContext.ARG_SCHEME.length());
		}
		return result;
	}

}
