package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.lang.dpml.ast.ILocation;
import org.netkernel.lang.dpml.ast.IScope;
import org.netkernel.lang.dpml.ast.IValue;
import org.netkernel.lang.dpml.ast.IValueVariable;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.request.IRequestScopeLevel;
import org.netkernel.request.IResponseMeta;


public class LiteralValue extends VariableImpl implements IValueVariable
{
	private final IValue mValue;
	
	public LiteralValue(String aName, IScope aScope,ILocation aLocation, Object aRepresentation, IResponseMeta aMeta)
	{	super(aName,aScope,aLocation);
		mValue = new ValueImpl(aRepresentation,aMeta);
	}

	public IValue getValue(INKFRequestContext aContext, IRequestScopeLevel aSubRequestContext, Class aRepresentationClass) throws NKFException
	{	
		return mValue;
	}
	
	public String toString()
	{	return "LiteralValue";
	}
	
	public boolean equals(Object aOther)
	{	return aOther instanceof LiteralValue && ((LiteralValue)aOther).mValue.equals(mValue);
	}
}
