package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.container.IKernel;
import org.netkernel.lang.dpml.ast.IVariable;
import org.netkernel.request.IRequest;
import org.netkernel.request.impl.MetaImpl;
import org.netkernel.request.impl.ResponseImpl;
import org.netkernel.urii.ClassLoaderWithExports;
import org.netkernel.urii.ISpace;

public class SequenceAssignmentsSpace implements ISpace
{
	private final Sequence mOwner;
	private final String mName;
	private final IVariable mVariable;
	private final SequenceAssignmentsSpace mPrevious;
	
	static final SequenceAssignmentsSpace sRoot = new SequenceAssignmentsSpace(null, null, null, null);
	
	public SequenceAssignmentsSpace(Sequence aOwner, String aName, IVariable aVariable, SequenceAssignmentsSpace aPrevious)
	{	mOwner=aOwner;
		mName=aName;
		mVariable=aVariable;
		mPrevious=aPrevious;
	}
	
	public Sequence getOwner()
	{	return mOwner;
	}
	
	public IVariable getAssignment(String aName)
	{	if (mName.equals(aName))
		{	return mVariable;
		}
		else if (mPrevious!=sRoot)
		{	return mPrevious.getAssignment(aName);
		}
		else
		{	return null;
		}
	}
	
	public ClassLoaderWithExports getClassLoader()
	{
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isCommissioned()
	{
		// TODO Auto-generated method stub
		return true;
	}

	public void onCommissionSpace(IKernel kernel)// throws Exception
	{
		// TODO Auto-generated method stub
		
	}

	public void onDecommissionSpace()
	{	
		// TODO Auto-generated method stub
		
	}

	public void onLinkSpace(IKernel kernel) throws Exception
	{
		// TODO Auto-generated method stub
		
	}

	public void postCommissionSpace() throws Exception
	{
		// TODO Auto-generated method stub
	}

	public void preDecommissionSpace() throws Exception
	{
		// TODO Auto-generated method stub
		
	}
	
	public int hashCode()
	{	return (mOwner==null)?0:mOwner.hashCode();
	}

	public boolean resolveEquals(Object other)
	{	boolean result=false;
		if (other instanceof SequenceAssignmentsSpace)
		{	result=mOwner==((SequenceAssignmentsSpace)other).mOwner;
		}
		return result;
	}
	
	public boolean equals(Object aOther)
	{	
		boolean result=aOther==this;
		if (!result && aOther instanceof SequenceAssignmentsSpace)
		{	SequenceAssignmentsSpace other = (SequenceAssignmentsSpace)aOther;
			result=mOwner==other.mOwner;
			if (result)
			{	SequenceAssignmentsSpace me = this;
				while (result && me!=sRoot && other!=sRoot)
				{	result = me.mVariable.equals(other.mVariable);
					me=me.mPrevious;
					other=other.mPrevious;
				}
			}
		}
		return result;
	}

	public void onAsyncRequest(IRequest aRequest)
	{
		// TODO Auto-generated method stub
		aRequest.getRequestor().onResponse(new ResponseImpl(aRequest,null,MetaImpl.NEVER_EXPIRED));
	}
	
	public String toString()
	{
		int c=0;
		SequenceAssignmentsSpace s=this;
		while (s!=sRoot)
		{	s=s.mPrevious;
			c++;
		}
		return "SequenceAssignmentsSpace-"+hashCode()+"-"+c;
	}

}
